// Form1.h (Test Client)

#pragma once

namespace RemotingShareTest {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/// <summary>
	/// Zusammenfassung fr Form1
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
    Form1(void)  // Test Client
    {
      InitializeComponent();
      //
      //TODO: Konstruktorcode hier hinzufgen.
      //

      m_svr = TestServer::Factory::GetServer();
      Text += String::Format(" #{0}", m_svr->GetClientInstanceNumber());
      lblGuiThreadId->Text = String::Format("GUI thread ID: {0}", Threading::Thread::CurrentThread->ManagedThreadId);
      lblIsServerDebugBuild->Text = String::Format("Server is debug build: {0}", m_svr->IsDebugBuild());
    }

	protected:
		/// <summary>
		/// Verwendete Ressourcen bereinigen.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}

  private:
    TestServer::Server ^m_svr;
  private: System::Windows::Forms::Label^  lblGuiThreadId;
  private: System::Windows::Forms::GroupBox^  groupBox1;
  private: System::Windows::Forms::Button^  bnSetSharedData;
  private: System::Windows::Forms::Button^  bnGetSharedData;
  private: System::Windows::Forms::TextBox^  txtSharedData;
  private: System::Windows::Forms::Label^  lblIsServerDebugBuild;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
      this->lblGuiThreadId = (gcnew System::Windows::Forms::Label());
      this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
      this->bnSetSharedData = (gcnew System::Windows::Forms::Button());
      this->bnGetSharedData = (gcnew System::Windows::Forms::Button());
      this->txtSharedData = (gcnew System::Windows::Forms::TextBox());
      this->lblIsServerDebugBuild = (gcnew System::Windows::Forms::Label());
      this->groupBox1->SuspendLayout();
      this->SuspendLayout();
      // 
      // lblGuiThreadId
      // 
      this->lblGuiThreadId->AutoSize = true;
      this->lblGuiThreadId->Location = System::Drawing::Point(12, 9);
      this->lblGuiThreadId->Name = L"lblGuiThreadId";
      this->lblGuiThreadId->Size = System::Drawing::Size(35, 13);
      this->lblGuiThreadId->TabIndex = 0;
      this->lblGuiThreadId->Text = L"label1";
      // 
      // groupBox1
      // 
      this->groupBox1->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
      this->groupBox1->Controls->Add(this->bnSetSharedData);
      this->groupBox1->Controls->Add(this->bnGetSharedData);
      this->groupBox1->Controls->Add(this->txtSharedData);
      this->groupBox1->Location = System::Drawing::Point(12, 25);
      this->groupBox1->Name = L"groupBox1";
      this->groupBox1->Size = System::Drawing::Size(265, 76);
      this->groupBox1->TabIndex = 1;
      this->groupBox1->TabStop = false;
      this->groupBox1->Text = L"Shared data";
      // 
      // bnSetSharedData
      // 
      this->bnSetSharedData->Location = System::Drawing::Point(87, 45);
      this->bnSetSharedData->Name = L"bnSetSharedData";
      this->bnSetSharedData->Size = System::Drawing::Size(75, 23);
      this->bnSetSharedData->TabIndex = 2;
      this->bnSetSharedData->Text = L"&Set";
      this->bnSetSharedData->UseVisualStyleBackColor = true;
      this->bnSetSharedData->Click += gcnew System::EventHandler(this, &Form1::bnSetSharedData_Click);
      // 
      // bnGetSharedData
      // 
      this->bnGetSharedData->Location = System::Drawing::Point(6, 45);
      this->bnGetSharedData->Name = L"bnGetSharedData";
      this->bnGetSharedData->Size = System::Drawing::Size(75, 23);
      this->bnGetSharedData->TabIndex = 1;
      this->bnGetSharedData->Text = L"&Get";
      this->bnGetSharedData->UseVisualStyleBackColor = true;
      this->bnGetSharedData->Click += gcnew System::EventHandler(this, &Form1::bnGetSharedData_Click);
      // 
      // txtSharedData
      // 
      this->txtSharedData->Anchor = static_cast<System::Windows::Forms::AnchorStyles>(((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Left) 
        | System::Windows::Forms::AnchorStyles::Right));
      this->txtSharedData->Location = System::Drawing::Point(6, 19);
      this->txtSharedData->Name = L"txtSharedData";
      this->txtSharedData->Size = System::Drawing::Size(253, 20);
      this->txtSharedData->TabIndex = 0;
      // 
      // lblIsServerDebugBuild
      // 
      this->lblIsServerDebugBuild->AutoSize = true;
      this->lblIsServerDebugBuild->Location = System::Drawing::Point(139, 9);
      this->lblIsServerDebugBuild->Name = L"lblIsServerDebugBuild";
      this->lblIsServerDebugBuild->Size = System::Drawing::Size(35, 13);
      this->lblIsServerDebugBuild->TabIndex = 2;
      this->lblIsServerDebugBuild->Text = L"label1";
      // 
      // Form1
      // 
      this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
      this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
      this->ClientSize = System::Drawing::Size(292, 112);
      this->Controls->Add(this->lblIsServerDebugBuild);
      this->Controls->Add(this->groupBox1);
      this->Controls->Add(this->lblGuiThreadId);
      this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
      this->MaximizeBox = false;
      this->Name = L"Form1";
      this->Text = L"Remoting Share Test Client";
      this->groupBox1->ResumeLayout(false);
      this->groupBox1->PerformLayout();
      this->ResumeLayout(false);
      this->PerformLayout();

    }
#pragma endregion

  // Event handlers

  private:
    System::Void bnGetSharedData_Click(System::Object^  sender, System::EventArgs^  e);
    System::Void bnSetSharedData_Click(System::Object^  sender, System::EventArgs^  e);
};
}

